// bbCode control by
// subBlue design
// www.subBlue.com

// Startup variables
var imageTag = false;
var theSelection = false;

// Check for Browser & Platform for PC & IE specific bits
// More details from: http://www.mozilla.org/docs/web-developer/sniffer/browser_type.html
var clientPC = navigator.userAgent.toLowerCase(); // Get client info
var clientVer = parseInt(navigator.appVersion); // Get browser version

var is_ie = ((clientPC.indexOf("msie") != -1) && (clientPC.indexOf("opera") == -1));
var is_nav  = ((clientPC.indexOf('mozilla')!=-1) && (clientPC.indexOf('spoofer')==-1)
                && (clientPC.indexOf('compatible') == -1) && (clientPC.indexOf('opera')==-1)
                && (clientPC.indexOf('webtv')==-1) && (clientPC.indexOf('hotjava')==-1));

var is_win   = ((clientPC.indexOf("win")!=-1) || (clientPC.indexOf("16bit") != -1));
var is_mac    = (clientPC.indexOf("mac")!=-1);


// Helpline messages
e_help = " : [e][/e]  (alt+e)";
i_help = " : [i][/i]  (alt+i)";
u_help = " : [u][/u]  (alt+u)";
k_help = ": [t][/t]  (alt+k)";
q_help = " : [q] [/q]  (alt+q)";
h_help = " : [h] [/h]  (alt+h)";
l_help = " : [*][/*] (alt+*)";
c_help = " : [c][/c]  (alt+c)";
pr_help = "   : [imgr]http://image_url[/img]";
p_help = " : [img]http://image_url[/img]  (alt+p)";
pl_help = "   : [imgl]http://image_url[/img]";
w_help = "  : [url]http://url[/url]  [url=http://url]  [/url]  (alt+w)";
m_help = " : [email]name@site.com[/email]  [email=name@site.com]  [/email]  (alt+m)";
a_help = "   seCode ";
s_help = " : [color=red][/color]";
f_help = " : [size=x-small] [/size]";
x_help = " : ([1])";
fo_help = " :[font=arial] Arial[/font]";

// Define the bbCode tags
bbcode = new Array();
bbtags = new Array('[e]','[/e]','[i]','[/i]','[u]','[/u]','[t]','[/t]','[q]','[/q]','[*]','[/*]','[c]','[/c]','[img]','[/img]','[url]','[/url]','[h]','[/h]','[email]','[/email]','[imgr]','[/img]','[imgl]','[/img]','([','])');
imageTag = false;

// Shows the help messages in the helpline window
function helpline(help) {
        document.post.helpbox.value = eval(help + "_help");
}


// Replacement for arrayname.length property
function getarraysize(thearray) {
        for (i = 0; i < thearray.length; i++) {
                if ((thearray[i] == "undefined") || (thearray[i] == "") || (thearray[i] == null))
                        return i;
                }
        return thearray.length;
}

// Replacement for arrayname.push(value) not implemented in IE until version 5.5
// Appends element to the array
function arraypush(thearray,value) {
        thearray[ getarraysize(thearray) ] = value;
}

// Replacement for arrayname.pop() not implemented in IE until version 5.5
// Removes and returns the last element of an array
function arraypop(thearray) {
        thearraysize = getarraysize(thearray);
        retval = thearray[thearraysize - 1];
        delete thearray[thearraysize - 1];
        return retval;
}


function checkForm() {

        formErrors = false;

        if (document.post.detail.value.length < 2) {
                formErrors = "       ";
        }

        if (formErrors) {
                alert(formErrors);
                return false;
        } else {
                bbstyle(-1);
                //formObj.preview.disabled = true;
                //formObj.submit.disabled = true;
                return true;
        }
}

function emoticon(text) {
        text = ' ' + text + ' ';
        if (document.post.detail.createTextRange && document.post.detail.caretPos) {
                var caretPos = document.post.detail.caretPos;
                caretPos.text = caretPos.text.charAt(caretPos.text.length - 1) == ' ' ? text + ' ' : text;
                document.post.detail.focus();
        } else {
        document.post.detail.value  += text;
        document.post.detail.focus();
        }
}

function bbfontstyle(bbopen, bbclose) {
        if ((clientVer >= 4) && is_ie && is_win) {
                theSelection = document.selection.createRange().text;
                if (!theSelection) {
                        document.post.detail.value += bbopen + bbclose;
                        document.post.detail.focus();
                        return;
                }
                document.selection.createRange().text = bbopen + theSelection + bbclose;
                document.post.detail.focus();
                return;
        } else {
                document.post.detail.value += bbopen + bbclose;
                document.post.detail.focus();
                return;
        }
        storeCaret(document.post.message);
}


function bbstyle(bbnumber) {

        donotinsert = false;
        theSelection = false;
        bblast = 0;

        if (bbnumber == -1) { // Close all open tags & default button names
                while (bbcode[0]) {
                        butnumber = arraypop(bbcode) - 1;
                        document.post.detail.value += bbtags[butnumber + 1];
                        buttext = eval('document.post.addbbcode' + butnumber + '.value');
                        eval('document.post.addbbcode' + butnumber + '.value ="' + buttext.substr(0,(buttext.length - 1)) + '"');
                }
                imageTag = false; // All tags are closed including image tags :D
                document.post.detail.focus();
                return;
        }

        if ((clientVer >= 4) && is_ie && is_win)
                theSelection = document.selection.createRange().text; // Get text selection

        if (theSelection) {
                // Add tags around selection
                document.selection.createRange().text = bbtags[bbnumber] + theSelection + bbtags[bbnumber+1];
                document.post.detail.focus();
                theSelection = '';
                return;
        }

        // Find last occurance of an open tag the same as the one just clicked
        for (i = 0; i < bbcode.length; i++) {
                if (bbcode[i] == bbnumber+1) {
                        bblast = i;
                        donotinsert = true;
                }
        }

        if (donotinsert) {                // Close all open tags up to the one just clicked & default button names
                while (bbcode[bblast]) {
                                butnumber = arraypop(bbcode) - 1;
                                document.post.detail.value += bbtags[butnumber + 1];
                                buttext = eval('document.post.addbbcode' + butnumber + '.value');
                                eval('document.post.addbbcode' + butnumber + '.value ="' + buttext.substr(0,(buttext.length - 1)) + '"');
                                imageTag = false;
                        }
                        document.post.detail.focus();
                        return;
        } else { // Open tags

                if (imageTag && (bbnumber != 14)) {                // Close image tag before adding another
                        document.post.detail.value += bbtags[15];
                        lastValue = arraypop(bbcode) - 1;        // Remove the close image tag from the list
                        document.post.addbbcode14.value = "Img";        // Return button back to normal state
                        imageTag = false;
                }

                // Open tag
                document.post.detail.value += bbtags[bbnumber];
                if ((bbnumber == 14) && (imageTag == false)) imageTag = 1; // Check to stop additional tags after an unclosed image tag
                arraypush(bbcode,bbnumber+1);
                eval('document.post.addbbcode'+bbnumber+'.value += "*"');
                document.post.detail.focus();
                return;
        }
        storeCaret(document.post.message);
}

// Insert at Claret position. Code from
// http://www.faqts.com/knowledge_base/view.phtml/aid/1052/fid/130
function storeCaret(textEl) {
        if (textEl.createTextRange) textEl.caretPos = document.selection.createRange().duplicate();
}


function add()
{
        opener.document.form.elements['st_main[news_text]'].value += document.post.detail.value;
        }